<html>
	<head>
		<meta charset="utf-8"/>
    <link rel="stylesheet" href="my.css">

		<script src="wasm_exec.js"></script>
    <!--
      The `wasm_exec.js` file is provided by the GoLang project. 
      It's a set of JavaScript helper functions which are called from WebAssembly.
      Ensure you are using the same version of `wasm_exec.js` as the version of Go you are using to compile.

      Use this command to get it:
      ```
      cp "$(go env GOROOT)/misc/wasm/wasm_exec.js" .
      ```
      
      **Remark**: `WebAssembly.instantiateStreaming` is the JavaScript API that allows to load the wasm file.
      
    -->

	</head>
	<body>
		<h1>WASM Experiments</h1>
		<script>
			// This is a polyfill for FireFox and Safari
			if (!WebAssembly.instantiateStreaming) { 
				WebAssembly.instantiateStreaming = async (resp, importObject) => {
					const source = await (await resp).arrayBuffer()
					return await WebAssembly.instantiate(source, importObject)
				}
			}

			// Promise to load the wasm file
      function loadWasm(path) {
        const go = new Go()

        return new Promise((resolve, reject) => {
          WebAssembly.instantiateStreaming(fetch(path), go.importObject)
          .then(result => {
            go.run(result.instance)
            resolve(result.instance)
          })
          .catch(error => {
            reject(error)
          })
        })
      }

			// Load the wasm file
			loadWasm("main.wasm").then(wasm => {
        console.log("main.wasm is loaded 👋")

        // put your code here


			}).catch(error => {
        console.log("ouch", error)
      }) 

		</script>
	</body>
</html>
